require "TimedActions/ISBaseTimedAction"

ORGMUnloadAction = ISBaseTimedAction:derive("ORGMUnloadAction")

function ORGMUnloadAction:isValid()
	if self.reloadable then
		return self.reloadable:isUnloadValid(self.character, self.square, self.mgr:getDifficulty())
	end
	return false
end

function ORGMUnloadAction:update()
end

function ORGMUnloadAction:start()
	if self.reloadable then
		self.reloadable:unloadStart(self.character, self.square, self.mgr:getDifficulty());
	end
end

function ORGMUnloadAction:stop()
	self.mgr:stopUnload()
	ISBaseTimedAction.stop(self)
end

function ORGMUnloadAction:perform()
	self.reloadable:unloadPerform(self.character, self.square, self.mgr:getDifficulty(), self.reloadWeapon)
	self.mgr.reloadable = self.reloadable -- goes nil sometimes 
    self.mgr.reloadWeapon = self.reloadWeapon
	self.mgr:stopUnloadSuccess()
	-- needed to remove from queue / start next.
	ISBaseTimedAction.perform(self)
end

function ORGMUnloadAction:new(unloadManager, char, square, time)
	local o = {}
	setmetatable(o, self) -- again with the useless metatable setting.....
	self.__index = self
	-- Required fields
	o.character = char
	o.stopOnWalk = false
	o.stopOnRun = true
	o.maxTime = time
	-- Custom fields
	o.mgr = unloadManager
    local moodles = char:getMoodles();
    local panicLevel = moodles:getMoodleLevel(MoodleType.Panic);
    if instanceof(unloadManager.reloadWeapon, "HandWeapon") then
        o.maxTime = unloadManager.reloadWeapon:getReloadTime() * char:getReloadingMod() + panicLevel*30
    else
        o.maxTime = time;
    end


	o.reloadable = unloadManager.reloadable
	o.reloadWeapon = unloadManager.reloadWeapon
	o.square = square
	return o
end

